/*============================================================================
//	aisa31bs.c
//
//	aISA-P31B
//
//	Copyright ADTEK SYSTEM SCIENCE Co.,Ltd.
//
//	V1.11 Date 1999/08/23
//
//	̿ɂׯ߰֐̎gpႪLqĂ܂B
//
//==========================================================================*/
#define	STRICT
#include <windows.h>
#include <tchar.h>
#include "aisa31bw.h"

const TCHAR szTitle[] = _T("Sample");
const TCHAR szP31B[]   = _T("aISA-P31B");

static void ResultMessage(LPCTSTR lpszbuf);
static void ErrorMessage(WORD wLogSlot);

/*============================================================================
//	۸т̊Jn
//===========================================================================*/
int WINAPI WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance, LPSTR lpCmdLine, int nCmdShow)
{
	WORD  wLogSlot;				/* ޲̘_ۯĔԍi[ */
	AISA31BRESOURCE Ri;			/* ؿ */
	DWORD dwDLLVer, dwDriverVer;
	BYTE  cbDat;
	BOOL  bResult;				/*  */
	TCHAR szBuf[256];

	/*-------------------------------------------------
	// aisa31b.dll ̎gp錾
	//-----------------------------------------------*/
	if (Aisa31bwDllOpen() == FALSE){
		ErrorMessage(AISA31B_SLOT_AUTO);
		return 1;				/* aisa31b.dll ۰ނɎs܂ */
	}
	/*-------------------------------------------------
	// ްޮݔԍ\
	// aISA-P31B DLL,ײްްޮݔԍ擾
	//-----------------------------------------------*/
	if (Aisa31bwGetVersion(&dwDLLVer, &dwDriverVer) == FALSE){
		ErrorMessage(AISA31B_SLOT_AUTO);
		return 1;
	}
	wsprintf(szBuf, _T("GetVersion\n")
					_T("DLL    Version\t: %08lxh\n")
					_T("Driver Version\t: %08lxh"),
					dwDLLVer,
					dwDriverVer);
	ResultMessage(szBuf);
	/*-------------------------------------------------
	// aISA-P31B̎gp錾
	//-----------------------------------------------*/
	wLogSlot = AISA31B_SLOT_AUTO;			/* gp޲T܂B*/
	bResult = Aisa31bwCreate(&wLogSlot);		/* ꍇA̎޲̘_ۯĔԍi[܂B*/
	if (bResult == FALSE){					/* ޲܂B*/
		ErrorMessage(AISA31B_SLOT_AUTO);
		return 1;
	}
	wsprintf(szBuf, _T("aISA-P31B Created\n\n")
					_T("LogSlot: %2d"),
					 wLogSlot);
	ResultMessage(szBuf);
	/*-------------------------------------------------
	// ؿ擾
	//-----------------------------------------------*/
	if (Aisa31bwGetResource(wLogSlot, &Ri) == FALSE){
		ErrorMessage(wLogSlot);
		return 1;
	}
	wsprintf(szBuf, _T("Board Name: %s\n")
					_T("IO Address: %04xh-%04xh\n"),
					szP31B,
					Ri.dwIOPortBase[0],
					Ri.dwIOPortBase[0] + Ri.dwIOPortLength[0] - 1);
	ResultMessage(szBuf);
	/*-------------------------------------------------
	// Port 1 ɔCӂްo
	//-----------------------------------------------*/
	cbDat = (BYTE)0xAA;
	if (Aisa31bwOutPort(wLogSlot, AISA31B_PORT_1, cbDat) == FALSE){
		ErrorMessage(wLogSlot);
		return 1;
	}
	wsprintf(szBuf, _T("Port 1 փf[^o\n")
					_T("Port 1 Out Data: %02xh"),
					 cbDat);
	ResultMessage(szBuf);
	/*-------------------------------------------------
	// Port 1 ްǂݍ
	//-----------------------------------------------*/
	cbDat = (BYTE)0x00;
	if (Aisa31bwInPort(wLogSlot, AISA31B_PORT_1, &cbDat) == FALSE){
		ErrorMessage(wLogSlot);
		return 1;
	}
	wsprintf(szBuf, _T("Port 1 f[^\n")
					_T("Port 1 In Data: %02xh"),
					 cbDat);
	ResultMessage(szBuf);
	/*-------------------------------------------------
	// aISA-P31B̎gpJ
	//-----------------------------------------------*/
	if (Aisa31bwClose(wLogSlot) == FALSE){
		ErrorMessage(wLogSlot);
		return 1;
	}
	ResultMessage(_T("aISA-P31B Closed"));
	/*-------------------------------------------------
	// aisa31b.dll ̎gpJ
	//-----------------------------------------------*/
	if (Aisa31bwDllClose() == FALSE){
		MessageBox(NULL, _T("DLL ̃A[hɎs܂B"), szTitle, MB_OK | MB_ICONSTOP);
		return 1;
	}
	return 0;
}
/*============================================================================
// ʂ\
//==========================================================================*/
static void ResultMessage(LPCTSTR lpszbuf)
{
	MessageBox(NULL, lpszbuf, szTitle, MB_OK | MB_ICONINFORMATION);
}
/*============================================================================
// װүނ\
//==========================================================================*/
static void ErrorMessage(WORD wLogSlot)
{
	DWORD dwRes = Aisa31bwGetLastError(wLogSlot);
	TCHAR szBuf[50];

	switch (dwRes){
		case AISA31B_ERR_SYSTEM:
			wsprintf(szBuf, _T("System error\n\n")
							_T("Error code: %08lxh"),
							GetLastError());
			break;
		case AISA31B_ERR_WRAPDLL:
			wsprintf(szBuf, _T("DLL Load error"));
			break;
		default:
			wsprintf(szBuf, _T("aISA-P31B error\n\n")
							_T("Error code: %08lxh"),
							dwRes);
			break;
	}
	MessageBox(NULL, szBuf, szTitle, MB_OK | MB_ICONSTOP);
}
